
// Field Analyzer ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Field Analyzer Example.h"
#include "Field Analyzer ExampleDlg.h"
#include "afxdialogex.h"
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CFieldAnalyzerExampleDlg dialog



CFieldAnalyzerExampleDlg::CFieldAnalyzerExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_FIELDANALYZEREXAMPLE_DIALOG, pParent)
	, cbUnits(_T(""))
	, numTimeBase(0)
	, numComposite(0)
	, chkFault(FALSE)
	, chkLaser(FALSE)
	, chkKeyPosition(FALSE)
	, chkTriggered(FALSE)
	, chkWebActive(FALSE)
	, chkSyncError(FALSE)
	, chkCommError(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFieldAnalyzerExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ADDRESS, txtAddress);
	DDX_CBString(pDX, IDC_UNITS, cbUnits);
	DDX_Text(pDX, IDC_TIMEBASE, numTimeBase);
	DDX_Control(pDX, IDC_MODEL, txtModel);
	DDX_Control(pDX, IDC_SERIAL, txtSerial);
	DDX_Control(pDX, IDC_FIRMWARE, txtFirmware);
	DDX_Text(pDX, IDC_COMPOSITE, numComposite);
	DDX_Check(pDX, IDC_FAULT, chkFault);
	DDX_Check(pDX, IDC_LASER, chkLaser);
	DDX_Check(pDX, IDC_KEYPOSITION, chkKeyPosition);
	DDX_Check(pDX, IDC_TRIGGERED, chkTriggered);
	DDX_Check(pDX, IDC_WEBACTIVE, chkWebActive);
	DDX_Check(pDX, IDC_SYNCERROR, chkSyncError);
	DDX_Check(pDX, IDC_COMMERROR, chkCommError);
	DDX_Control(pDX, IDC_READ, btnRead);
}

BEGIN_MESSAGE_MAP(CFieldAnalyzerExampleDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INITIALIZE, &CFieldAnalyzerExampleDlg::OnBnClickedInitialize)
	ON_BN_CLICKED(IDC_READ, &CFieldAnalyzerExampleDlg::OnBnClickedRead)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CFieldAnalyzerExampleDlg message handlers

BOOL CFieldAnalyzerExampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialize the address to a valid GPIB resource
	txtAddress.SetWindowText(TEXT("GPIB::5::INSTR"));

	numTimeBase = 20;
	cbUnits = "V/m";

	UpdateData(false);

	btnRead.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFieldAnalyzerExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFieldAnalyzerExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CFieldAnalyzerExampleDlg::OnBnClickedInitialize()
{
	CString address;
	txtAddress.GetWindowText(address);

	UpdateData(true);

	fa.Close();

	// Initialize a new session
	if (fa.Initialize(string(address), false) == 0)
	{
		// Query information about the attached probe
		ProbeID probe = fa.QueryProbeID();
		txtModel.SetWindowText(probe.model.c_str());
		txtSerial.SetWindowText(probe.serial.c_str());
		txtFirmware.SetWindowText(probe.firmware.c_str());

		// Set the units
		if (cbUnits == "mW/cm2")
			fa.ConfigureUnits(mWcm2);
		else if (cbUnits == "W/m2")
			fa.ConfigureUnits(Wm2);
		else
			fa.ConfigureUnits(Vm);

		// Set the trigger to free run
		fa.ConfigureTriggerMode(FREERUN);

		// Configure the time base
		fa.ConfigureTimeBase(numTimeBase);

		// Enable the read button
		btnRead.EnableWindow(TRUE);
	}	
}


void CFieldAnalyzerExampleDlg::OnBnClickedRead()
{
	// Read the composite field value from the FA
	numComposite = fa.ReadCompositeField();

	// Check the status
	Status sta = fa.QueryStatus();

	chkFault = sta.fault;
	chkLaser = sta.laser;
	chkKeyPosition = sta.keyPosition;
	chkTriggered = sta.triggered;
	chkWebActive = sta.webActive;
	chkSyncError = sta.syncError;
	chkCommError = sta.internalCommError;

	UpdateData(false);
}


void CFieldAnalyzerExampleDlg::OnClose()
{
	// Close the VISA session
	fa.Close();

	CDialogEx::OnClose();
}
